/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import javax.swing.*;

/**
 * Classe correspondant  un modle de tuyre
 * Il y a deux moyens de calculer le composant : 
 *      - soit dterminer la pression de sortie connaissant la vitesse des gaz  l'entre
 *      - soit dterminer la vitesse des gaz en sortie connaissant la pression  l'entre
 * 
 * Le rendement isentropique est entr en paramtre dans le champ eta_s_value
 *
 * La vitesse des gaz  l'entre est entre en paramtre dans le champ Cin_value
 *
 * La vitesse des gaz en sortie est affiche dans le champ Cout_value
 * La pression de sortie est affiche dans le champ pOut_value
 * La section de sortie est affiche dans le champ outSection_value
 * La section minimale, si elle existe, est affiche dans le champ minSection_value
 * Le nombre de Mach en sortie est affich dans le champ Ma_value
 * 
 * @author Renaud GICQUEL
 */
public class Nozzle extends ExtProcess 
{
	final ButtonGroup groupSystemType=new ButtonGroup();
	javax.swing.JRadioButton calcP = new javax.swing.JRadioButton();
	javax.swing.JRadioButton calcC = new javax.swing.JRadioButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField pOut_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Ma_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField eta_s_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField cIn_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField cOut_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField outSection_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField minSection_value = new javax.swing.JTextField();
    
    double  P, Cin,Cout, outSection, minSection, Ma,eta_s;
    double Tamont, Taval, Pamont, Paval;
    double Hamont,Samont;
    double flow;
    
    public Nozzle (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("outlet pressure (bar)");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,90,164,24);
		JPanel1.add(pOut_value);
		pOut_value.setBounds(164,90,124,24);
		pOut_value.setText("0.8");
		JPanel1.add(calcP);
		calcP.setBounds(164,200,200,24);
		calcP.setText("Calculate outlet pressure");
		JPanel1.add(calcC);
		calcC.setBounds(164,230,200,24);
		calcC.setText("Calculate outlet velocity");
		JLabel2.setText("Mach number");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,60,164,24);
		JPanel1.add(Ma_value);
		Ma_value.setBounds(164,60,124,24);
		Ma_value.setText("0");
		JLabel3.setText("isentropic efficiency");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,30,164,24);
		JPanel1.add(eta_s_value);
		eta_s_value.setBounds(164,30,124,24);
		eta_s_value.setText("1");
		JLabel4.setText("inlet velocity (m/s)");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,0,164,24);
		JPanel1.add(cIn_value);
		cIn_value.setBounds(164,0,124,24);
		cIn_value.setText("10");
		JLabel5.setText("outlet velocity (m/s)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,120,164,24);
		JPanel1.add(cOut_value);
		cOut_value.setBounds(164,120,124,24);
		cOut_value.setText("10");
		JLabel6.setText("outlet section");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,150,164,24);
		JPanel1.add(outSection_value);
		outSection_value.setBounds(164,150,124,24);
		outSection_value.setText("1");
		JLabel7.setText("minimum section");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,180,164,24);
		JPanel1.add(minSection_value);
		minSection_value.setBounds(164,180,124,24);
		minSection_value.setText("0.8");
		type=getType();
   		thermoCouplerTypes=new String[0];//no thermocoupler connected
	    groupSystemType.add(calcP);
	    groupSystemType.add(calcC);
 }
    
    public String getType(){
        return "nozzle";
    }
	public String getClassDescription(){
	    return "adiabatic nozzle model\n\nauthor : R. Gicquel april 2006\n\nRef : archive Nozzle.zip";
	}
    public String getName(){
        return tfe.getCompName();
    }
    public void setInletVelocity(double C){
        Cin=C;
	    cIn_value.setText(Util.aff_d(Cin,2));
    }
    
    public double getOutletVelocity(){
        return Cout;
    }
    public double getFlow(){
        return flow;
    }
    public void setAmbientConditions(double Text, double Pext){
	    Tpoint=Text;
	    Ppoint=Pext;
        tfe.setupPointAmont(getProperties());
    }
    public void setExternalPressure(double Pext){
        P=Pext;
	    pOut_value.setText(Util.aff_d(Pext,3));
    }
    
	public void calculateProcess(){
      String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Pamont=Ppoint;
        Hamont=Hpoint;
        Samont=Spoint;

        //chargement des valeurs affiches  l'cran 
        P=Util.lit_d(pOut_value.getText());
        Cin=Util.lit_d(cIn_value.getText());
        Cout=Util.lit_d(cOut_value.getText());
        eta_s=Util.lit_d(eta_s_value.getText());
        
        double HtotAmont=Hamont+Cin*Cin/2000;
        if(calcP.isSelected()){//calcul de la pression de sortie
        
            
            double Haval=HtotAmont-Cout*Cout/2000;
            double Hisentr=HtotAmont-Cout*Cout/2000/eta_s;//enthalpie du point aval
            double Tisentr=lecorps.getT_from_hP(Hisentr,Pamont);
            Paval=lecorps.getP_from_sT(Samont,Tisentr);//inversion en P de la fonction entropie (pression de stagnation polytropique)
  
            Taval=lecorps.getT_from_hP(Haval,Pamont);//inversion en T de la fonction enthalpie (temprature de stagnation isentropique)
	        pOut_value.setText(Util.aff_d(Paval,5));
            
        }
        else{
            Taval=lecorps.getT_from_sP(Samont,P);//inversion en T de la fonction entropie (temprature de stagnation isentropique)
	        lecorps.CalcPropCorps(Taval,P, 1);
            getSubstProperties(nomCorps);
	        double r=8.314/Msubst;
	        
            Cout=Math.pow(2000.*(HtotAmont-Hsubst)*eta_s, 0.5);//vitesse de sortie (quation 6 de la notice)
	        cOut_value.setText(Util.aff_d(Cout,2));
	        Paval=P;
	        
        }
	    Tpoint=Taval;
	    Ppoint=Paval;
        tfe.setupPointAval(getProperties());
        
        //calcul des sections
	    lecorps.CalcPropCorps(Taval+1,P, 1);  
        getSubstProperties(nomCorps);
	    double H1=Hsubst;
        Taval=lecorps.getT_from_sP(Samont,P);
	    lecorps.CalcPropCorps(Taval,P, 1);
        getSubstProperties(nomCorps);
	    
        //estimation du Cp amont (on fait les calculs avec l'hypothse d'un gaz parfait pour ce Cp)
	    double Cp=H1-Hsubst;
	    double r=8.314/Msubst;
	    double gamma=Cp/(Cp-r);
	    
	    //calcul de la section de sortie
        outSection=flow*r/Paval/100*Taval/Cout;
	    outSection_value.setText(Util.aff_d(outSection,4));
	    
	    //calcul de la section contracte (quation 7 de la notice)
	    double Cs=Math.pow(gamma*r*Taval*1000, 0.5);
	    Ma=Cout/Cs;
		Ma_value.setText(Util.aff_d(Ma,3));
	    double x=1+(gamma-1)/2.*Ma*Ma;
	    x=x*2./(gamma+1.);
	    double beta=(gamma+1)/2./(gamma-1);
	    double y=Math.pow(x, beta);
	    if(Ma<=1)minSection=outSection;
	    else minSection=outSection*Ma/y;
	    minSection_value.setText(Util.aff_d(minSection,4));
	    
	}
	
	public double getSpeed(double Ma, double Text, double Pext){
	    lecorps.CalcPropCorps(Text+1,Pext, 1);  
        getSubstProperties(nomCorps);
	    double H1=Hsubst;
	    lecorps.CalcPropCorps(Text,Pext, 1);
        getSubstProperties(nomCorps);
	    double Cp=H1-Hsubst;
	    double r=8.314/Msubst;
	    double gamma=Cp/(Cp-r);
	    double Cs=Math.pow(gamma*r*Text*1000, 0.5);
	    return Ma*Cs;
	}
    
	public void readCompParameters(String ligne_data){
		P=Util.lit_d(Util.extr_value(ligne_data, "pOut_value"));
		Cin=Util.lit_d(Util.extr_value(ligne_data, "cIn_value"));
	    pOut_value.setText(Util.aff_d(P,5));
	    cIn_value.setText(Util.aff_d(Cin,2));
	    calcP.setSelected(Util.lit_b(Util.extr_value(ligne_data, "calcP_value")));
	    calcC.setSelected(Util.lit_b(Util.extr_value(ligne_data, "calcC_value")));
		Cout=Util.lit_d(Util.extr_value(ligne_data, "cOut_value"));
	    cOut_value.setText(Util.aff_d(Cout,2));
        outSection=Util.lit_d(Util.extr_value(ligne_data, "outSection_value"));
	    outSection_value.setText(Util.aff_d(outSection,4));
        Ma=Util.lit_d(Util.extr_value(ligne_data, "Ma_value"));
	    Ma_value.setText(Util.aff_d(Ma,3));
	    minSection=Util.lit_d(Util.extr_value(ligne_data, "minSection_value"));
	    minSection_value.setText(Util.aff_d(minSection,4));
		eta_s=Util.lit_d(Util.extr_value(ligne_data, "epsi_p_value"));
	    eta_s_value.setText(Util.aff_d(eta_s,4));
	}
	
    public String saveCompParameters(){
	    String h="pOut_value="+pOut_value.getText()+tab
	    +"cIn_value="+cIn_value.getText()+tab
	    +"calcP_value="+Util.aff_b(calcP.isSelected()) +tab
	    +"calcC_value="+Util.aff_b(calcC.isSelected()) +tab
	    +"cOut_value="+cOut_value.getText()+tab
	    +"Ma_value="+Ma_value.getText()+tab
	    +"outSection_value="+outSection_value.getText()+tab
	    +"minSection_value="+minSection_value.getText()+tab
	    +"epsi_p_value="+eta_s_value.getText()+tab
	    ;
        return h;
    }
 

}